Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/Collection.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/Collection.java	(revision 24426)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/collection/Collection.java	(revision 24427)
@@ -421,15 +421,8 @@
 		response.setAttribute(GSXML.TYPE_ATT, type);
 
-		logger.error("Collection received a message, attempting to process");
-
 		if (type.equals(GSXML.REQUEST_TYPE_FORMAT_STRING))
 		{
-			logger.error("Received format string request");
-
 			String subaction = request.getAttribute("subaction");
-			logger.error("Subaction is " + subaction);
-
 			String service = request.getAttribute("service");
-			logger.error("Service is " + service);
 
 			String classifier = null;
@@ -437,14 +430,8 @@
 			{
 				classifier = request.getAttribute("classifier");
-				logger.error("Classifier is " + classifier);
-			}
-
-			//logger.error("Format string: " + format_string);
-			logger.error("Config file location = " + GSFile.collectionConfigFile(this.site_home, this.cluster_name));
-
+			}
+			
 			// check for version file
-
 			String directory = new File(GSFile.collectionConfigFile(this.site_home, this.cluster_name)).getParent() + File.separator;
-			logger.error("Directory is " + directory);
 
 			String version_filename = "";
@@ -455,5 +442,4 @@
 
 			File version_file = new File(version_filename);
-			logger.error("Version filename is " + version_filename);
 
 			if (subaction.equals("update"))
@@ -495,6 +481,4 @@
 						format_statement_filename = directory + "query_format_statement_v" + version_number + ".txt";
 
-					logger.error("Format statement filename is " + format_statement_filename);
-
 					// Write format statement
 					String format_string = this.converter.getString(format_statement); //GSXML.xmlNodeToString(format_statement);
@@ -523,7 +507,5 @@
 				Element display_format = (Element) format_element.getFirstChild();
 
-				logger.error("I have received a save document request");
 				String format_string = GSXML.xmlNodeToString(display_format);
-				logger.error("Param=" + format_string);
 				String collection_config = directory + "collectionConfig.xml";
 				Document config = this.converter.getDOM(new File(collection_config), "UTF-8");
@@ -534,11 +516,8 @@
 				if (GSXML.getChildByTagName(current_node, "display") == null)
 				{
-					logger.error("ERROR: does not have a display child");
 					// well then create a format tag
 					Element display_tag = config.createElement("display");
 					current_node = (Node) current_node.appendChild(display_tag);
-					//current_node = (Node) format_tag;
-				}
-
+				}
 				else
 				{
@@ -548,16 +527,11 @@
 				if (GSXML.getChildByTagName(current_node, "format") == null)
 				{
-					logger.error("ERROR: does not have a format child");
 					// well then create a format tag
 					Element format_tag = config.createElement("format");
 					current_node.appendChild(format_tag);
-					//current_node = (Node) format_tag;
 				}
 
 				current_node.replaceChild(config.importNode(display_format, true), GSXML.getChildByTagName(current_node, "format"));
 
-				logger.error(GSXML.xmlNodeToString(current_node));
-
-				logger.error("Convert config to string");
 				String new_config = this.converter.getString(config);
 
@@ -572,5 +546,4 @@
 					writer.write(new_config);
 					writer.close();
-					logger.error("All is happy with collection saveDocument");
 				}
 				catch (IOException e)
@@ -582,13 +555,9 @@
 			if (subaction.equals("save"))
 			{
-				logger.error("SAVE format statement");
-
 				Element format_element = (Element) GSXML.getChildByTagName(request, GSXML.FORMAT_STRING_ELEM);
-				//String format_string = GSXML.getNodeText(format_element);
 				Element format_statement = (Element) format_element.getFirstChild();
 
 				try
 				{
-
 					// open collectionConfig.xml and read in to w3 Document
 					String collection_config = directory + "collectionConfig.xml";
@@ -604,6 +573,4 @@
 					NodeList current_node_list;
 
-					logger.error("Service is " + service);
-
 					if (service.equals("ClassifierBrowse"))
 					{
@@ -612,5 +579,4 @@
 						// default is <browse><format>
 
-						logger.error("Looking for browse");
 						current_node = GSXML.getChildByTagName(current_node, "browse");
 
@@ -618,9 +584,7 @@
 						if (classifier != null)
 						{
-							logger.error("Classifier is not null");
-							logger.error("Classifier is " + classifier);
 							current_node_list = GSXML.getChildrenByTagName(current_node, "classifier");
 							index = Integer.parseInt(classifier.substring(2)) - 1;
-							logger.error("classifier index is " + index);
+
 							// index should be given by X-1
 							current_node = current_node_list.item(index);
@@ -628,22 +592,17 @@
 							if (GSXML.getChildByTagName(current_node, "format") == null)
 							{
-								logger.error("ERROR: valid classifier but does not have a format child");
 								// well then create a format tag
 								Element format_tag = config.createElement("format");
 								current_node.appendChild(format_tag);
-								//current_node = (Node) format_tag;
 							}
 						}
 						else
 						{
-							logger.error("Classifier is null");
 							// To support all classifiers, set classifier to null?  There is the chance here that the format tag does not exist
 							if (GSXML.getChildByTagName(current_node, "format") == null)
 							{
-								logger.error("ERROR: classifier does not have a format child");
 								// well then create a format tag
 								Element format_tag = config.createElement("format");
 								current_node.appendChild(format_tag);
-								//current_node = (Node) format_tag;
 							}
 						}
@@ -651,13 +610,10 @@
 					else if (service.equals("AllClassifierBrowse"))
 					{
-						logger.error("Looking for browse");
 						current_node = GSXML.getChildByTagName(current_node, "browse");
 						if (GSXML.getChildByTagName(current_node, "format") == null)
 						{
-							logger.error("ERROR AllClassifierBrowse: all classifiers do not have a format child");
 							// well then create a format tag
 							Element format_tag = config.createElement("format");
 							current_node.appendChild(format_tag);
-							//current_node = (Node) format_tag;
 						}
 					}
@@ -665,6 +621,4 @@
 					{
 						// look in <format> with no attributes
-						logger.error("I presume this is search");
-
 						current_node_list = GSXML.getChildrenByTagName(current_node, "search");
 						for (k = 0; k < current_node_list.getLength(); k++)
@@ -681,5 +635,4 @@
 
 					// Now convert config document to string for writing to file
-					logger.error("Convert config to string");
 					String new_config = this.converter.getString(config);
 
@@ -692,5 +645,4 @@
 					writer.write(new_config);
 					writer.close();
-					logger.error("All is happy with collection");
 
 				}
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java	(revision 24426)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/service/DocumentMaker.java	(revision 24427)
@@ -55,18 +55,9 @@
 	protected static final String DOCUMENT_GET_INFORMATION = "DocumentGetInformation";
 
-	//Metadata services
-	protected static final String DOCUMENT_GET_METADATA = "DocumentGetMetadata";
-	protected static final String DOCUMENT_ADD_METADATA = "DocumentAddMetadata";
-	protected static final String DOCUMENT_DELETE_METADATA = "DocumentDeleteMetadata";
-
-	//Document text services
-	protected static final String DOCUMENT_GET_TEXT = "DocumentGetText";
-	protected static final String DOCUMENT_SET_TEXT = "DocumentSetText";
-
 	//Other services
 	protected static final String DOCUMENT_EXECUTE_TRANSACTION = "DocumentExecuteTransaction";
 	/***************************************************/
 
-	String[] services = { DOCUMENT_CREATE, DOCUMENT_DELETE, DOCUMENT_DUPLICATE, DOCUMENT_GET_INFORMATION, DOCUMENT_MOVE, DOCUMENT_MERGE, DOCUMENT_SPLIT, DOCUMENT_GET_METADATA, DOCUMENT_ADD_METADATA, DOCUMENT_DELETE_METADATA, DOCUMENT_GET_TEXT, DOCUMENT_SET_TEXT, DOCUMENT_EXECUTE_TRANSACTION };
+	String[] services = { DOCUMENT_CREATE, DOCUMENT_DELETE, DOCUMENT_DUPLICATE, DOCUMENT_GET_INFORMATION, DOCUMENT_MOVE, DOCUMENT_MERGE, DOCUMENT_SPLIT, DOCUMENT_EXECUTE_TRANSACTION };
 
 	/** configure this service */
@@ -360,4 +351,3 @@
 		return null;
 	}
-
 }